<template>
  <div v-if="images && images.length">
    <no-ssr>
      <div
        class="photo-swiper"
        :class="classModifier">
        <div v-swiper:mySwiper="swiperOption">
          <div class="swiper-wrapper">
            <div
              class="swiper-slide"
              v-for="(image, index) in images"
              :key="index">
              <div class="image">
                <div class="image-container">
                  <img
                    :src="image.url"
                    :alt="image.alt">
                </div>
              </div>
            </div>
          </div>
          <!-- <div class="swiper-pagination"></div> -->
          <div
            class="swiper-button-prev"
            v-if="images.length > 1"/>
          <div
            class="swiper-button-next"
            v-if="images.length > 1"/>
        </div>
      </div>
    </no-ssr>
  </div>
</template>

<script>
import Vue from 'vue';

const VueAwesomeSwiper = process.client ? require('vue-awesome-swiper/dist/ssr') : null;

if (VueAwesomeSwiper !== null) {
  Vue.use(VueAwesomeSwiper);
}

export default {
  name: 'SliderCarousel',
  props: {
    images: {
      type: Array,
      default() { return []; },
    },
    currentIndex: {
      type: Number,
      default: 0,
    },
    classModifier: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      swiperOption: {
        slidesPerView: 1,
        spaceBetween: 40,
        grabCursor: true,
        watchOverflow: true,
        loop: true,
        centeredSlides: true,
        effect: 'fade',
        zoom: false,
        pagination: {
          el: '.swiper-pagination',
          dynamicBullets: true,
          type: 'fraction',
        },
        navigation: {
          nextEl: '.swiper-button-next',
          prevEl: '.swiper-button-prev',
        },
      },
    };
  },
};
</script>

<style scoped lang="scss">
  @import "~/assets/scss/modules/_vue-swiper.scss";

  .photo-swiper {
    width: 100%;
    max-width: 25rem;
    height: 14.25rem;
    display: flex;
    align-items: stretch;

    &.modal {
      width: auto;
      height: auto;
      max-width: 100%;
      max-height: 100%;

      .swiper-slide {
        height: auto!important;
        width: auto !important;
        border: none;
        overflow: visible;

        img {
          display: block;
          max-width: 100%;
          height: 100%;
        }

        opacity: 0!important;

        &.swiper-slide-active {
          opacity: 1!important;
        }
      }
    }
    &:not(.modal) {

      .swiper-slide .image {
        display: flex;
        justify-content: center;
        align-items: center;
        border: 1px solid #6A7B87;
        border-radius: 3px;
        background-color: #fff;
        width: 100%;
        max-width: 25rem;
        min-width: 15rem;
        overflow: hidden;

        .image-container {
          display: block;
          height: 0;
          width: 100%;
          padding-top: 80%;
          overflow: hidden;
          position: relative;

          & > img {
            position: absolute;
            top: 50%;
            left: 50%;
            object-fit: cover;
            max-width: none;
            max-height: none;
            width: 101%;
            height: 100%;
            -webkit-transform: translate(-50%, -50%);
            transform: translate(-50%, -50%);
          }
        }
      }
    }
    .swiper-container {
      padding: 0 2rem 2rem;
    }
    .swiper-wrapper {
      overflow: hidden;
    }
    .swiper-slide {
      display: flex;
      flex-flow: column nowrap;
      justify-content: center;
      align-items: center;
      font-size: 0;
      background: #fff;
    }
    .swiper-pagination {
      width: 100%;
      font-size: 0.9375rem;
      font-weight: 500;
      bottom: 0.25rem;
      left: 0;
    }
    .swiper-button-prev {
      left: 0;
    }
    .swiper-button-next {
      right: 0;
    }
  }
</style>
